/* 
 * FreeSWITCH Modular Media Switching Software Library / Soft-Switch Application
 * Copyright (C) 2005/2006, Anthony Minessale II <anthmct@yahoo.com>
 *
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is FreeSWITCH Modular Media Switching Software Library / Soft-Switch Application
 *
 * The Initial Developer of the Original Code is
 * Anthony Minessale II <anthmct@yahoo.com>
 * Portions created by the Initial Developer are Copyright (C)
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 
 *
 *
 * mod_squirrelfish.c -- Squirrelfish (WebKit JavaScript Engine) Language Module
 *
 */
#ifndef _MOD_SQUIRRELFISH_PRIV_H_
#define _MOD_SQUIRRELFISH_PRIV_H_

/*
 * Private defines and typedefs
 */

/*
 * Session class forward declarations
 */
//static void sessionClass_Initialize(JSContextRef ctx, JSObjectRef object);
//static void sessionClass_Finalize(JSObjectRef object);

static bool sessionClass_HasProperty(JSContextRef ctx, JSObjectRef object, JSStringRef propertyName);
static JSValueRef sessionClass_GetProperty(JSContextRef ctx, JSObjectRef object, JSStringRef propertyName, JSValueRef* exception);
static bool sessionClass_SetProperty(JSContextRef ctx, JSObjectRef object, JSStringRef propertyName, JSValueRef value, JSValueRef* exception);
static bool sessionClass_DeleteProperty(JSContextRef ctx, JSObjectRef object, JSStringRef propertyName, JSValueRef* exception);
//static void sessionClass_GetPropertyNames(JSContextRef ctx, JSObjectRef object, JSPropertyNameAccumulatorRef propertyNames);

//static JSValueRef sessionClass_CallAsFunction(JSContextRef ctx, JSObjectRef function, JSObjectRef thisObject, size_t argumentCount, const JSValueRef arguments[], JSValueRef* exception);
//static JSObjectRef sessionClass_CallAsConstructor(JSContextRef ctx, JSObjectRef constructor, size_t argumentCount, const JSValueRef arguments[], JSValueRef* exception);
//static bool sessionClass_HasInstance(JSContextRef ctx, JSObjectRef constructor, JSValueRef possibleInstance, JSValueRef* exception);
//static JSValueRef sessionClass_ConvertToType(JSContextRef ctx, JSObjectRef object, JSType type, JSValueRef* exception);

static JSValueRef session_ready_cb(JSContextRef context, JSObjectRef thisObject);
static JSValueRef session_state_cb(JSContextRef context, JSObjectRef thisObject);

static JSValueRef session_answer_cb(JSContextRef context, JSObjectRef functionObject, JSObjectRef thisObject,
				 size_t argumentCount, const JSValueRef arguments[], JSValueRef* exception);

static JSValueRef session_pre_answer_cb(JSContextRef context, JSObjectRef functionObject, JSObjectRef thisObject,
				 size_t argumentCount, const JSValueRef arguments[], JSValueRef* exception);

static JSValueRef session_hangup_cb(JSContextRef context, JSObjectRef functionObject, JSObjectRef thisObject,
				 size_t argumentCount, const JSValueRef arguments[], JSValueRef* exception);

#endif

